{% extends "base.html" %}
{% load humanize %}
{% block title %}- {% trans "Наблюдения" %}{% endblock %}

{% block css %}
<link rel="stylesheet"
  href="{% static 'lib/@eonasdan/tempus-dominus/dist/css/tempus-dominus.min.css' %}">
<link rel="stylesheet"
  href="{% static 'lib/bootstrap-select/dist/css/bootstrap-select.min.css' %}">
<link rel="stylesheet"
  type="text/scss"
  href="{% static 'css/pages/observations.scss' %}">
{% endblock css %}

{% block body-class %}class="observations"{% endblock %}

{% block content %}
<section class="container block-h1">
  <h1>{% trans "Наблюдения" %}</h1>
</section>
<section class="tables-filtering container">
  <span class="row actions">
    {% if can_schedule %}
    <a class="btn btn-small btn-orange"
      href="{% url 'base:observation_new' %}">
      <span class="bi bi-plus"></span>
      {% trans "Новое наблюдение" %}
    </a>
    {% endif %}
    <a class="btn btn-small btn-outline-gray modal-obs"
      data-toggle="modal"
      data-target="#modalobservationsInfo"
      data-target-type="modal">
      <span class="bi bi-info-circle"></span>
    </a>
  </span>
  <form action=""
    id="observationsFilteringForm"
    class="tables-filtering__form"
    data-url_query="{% url 'base:vet_observations' %}?{{ vet_url_query }}">
    <div class="row">
      <div class="form-group col">
        <label>{% trans "Статус" %}
          <div class="checkbox-group">
            <label class="btn btn-blue btn-sm {% if future == '0' %}inactive{% endif %}"
              aria-expanded="true"
              aria-controls="future"
              data-toggle="tooltip"
              data-placement="bottom"
              title="{% trans 'Будущие' %}">
              <input type="checkbox"
                name="future"
                value="0"
                {% if future == '0' %}checked{% endif %}
                autocomplete="off">
              <span class="bi bi-clock"
                aria-hidden="true"></span>
            </label>
            <label class="btn btn-green btn-sm {% if good == '0' %}inactive{% endif %}"
              aria-expanded="true"
              aria-controls="good"
              data-toggle="tooltip"
              data-placement="bottom"
              title="{% trans 'Хорошие' %}">
              <input type="checkbox"
                name="good"
                value="0"
                {% if good == '0' %}checked{% endif %}
                autocomplete="off">
              <span class="bi bi-check"
                aria-hidden="true"></span>
            </label>
            <label class="btn btn-red btn-sm {% if bad == '0' %}inactive{% endif %}"
              aria-expanded="true"
              aria-controls="bad"
              data-toggle="tooltip"
              data-placement="bottom"
              title="{% trans 'Плохие' %}">
              <input type="checkbox"
                name="bad"
                value="0"
                {% if bad == '0' %}checked{% endif %}
                autocomplete="off">
              <span class="bi bi-x"
                aria-hidden="true"></span>
            </label>
            <label class="btn btn-orange btn-sm {% if unknown == '0' %}inactive{% endif %}"
              aria-expanded="true"
              aria-controls="unknown"
              data-toggle="tooltip"
              data-placement="bottom"
              title="{% trans 'Неизвестные' %}">
              <input type="checkbox"
                name="unknown"
                value="0"
                {% if unknown == '0' %}checked{% endif %}
                autocomplete="off">
              <span class="bi bi-question-circle"
                aria-hidden="true"></span>
            </label>
            <label class="btn btn-gray btn-sm {% if failed == '0' %}inactive{% endif %}"
              aria-expanded="true"
              aria-controls="failed"
              data-toggle="tooltip"
              data-placement="bottom"
              title="{% trans 'Неудавшиеся' %}">
              <input type="checkbox"
                name="failed"
                value="0"
                {% if failed == '0' %}checked{% endif %}
                autocomplete="off">
              <span class="bi bi-exclamation-triangle"
                aria-hidden="true"></span>
            </label>
          </div>
        </label>
      </div>
      <div class="form-group col">
        <label>{% trans "Спутник" %}
          <select class="form-control selectpicker"
            data-style="btn"
            name="norad"
            autocomplete="off"
            id="satellite-selection"
            data-size="20"
            data-live-search="true"
            data-live-search-placeholder="{% trans 'NORAD | Название спутника | Позывной' %}">
            <option value=""
              selected>{% trans 'Все' %}</option>
            {% for satellite in satellites %}
            <option data-norad="{{ satellite.norad_cat_id }}"
              value="{{ satellite.norad_cat_id }}"
              {% if satellite.norad_cat_id == norad %}selected{% endif %}>
              {{ satellite.norad_cat_id }} - {{ satellite.name }}
            </option>
            {% endfor %}
          </select>
        </label>
      </div>
      <div class="form-group col">
        <label class="datetimepicker-start control-label">
          {% trans 'Начало периода' %}
          <div class='input-group datetimepicker'
            id="datetimepicker-start"
            {% if start is not None %}data-value="{{ start }}"
            {% endif %}
            data-td-target-input="nearest"
            data-td-target-toggle="nearest">
            <input data-td-target="#datetimepicker-start"
              type="text"
              name="start"
              autocomplete="off" />
            <span class="input-group-append"
              data-td-target="#datetimepicker-start"
              data-td-toggle="datetimepicker">
              <i class="input-group-text bi bi-calendar3"></i>
            </span>
          </div>
        </label>
      </div>
      <div class="form-group col">
        <label class="control-label">
          {% trans "Конец периода" %}
          <div class='input-group datetimepicker'
            id="datetimepicker-end"
            {% if end is not None %}data-value="{{ end }}"
            {% endif %}
            data-td-target-input="nearest"
            data-td-target-toggle="nearest">
            <input data-td-target="#datetimepicker-end"
              type="text"
              name="end"
              autocomplete="off" />
            <span class="input-group-append"
              data-td-target="#datetimepicker-end"
              data-td-toggle="datetimepicker">
              <i class="input-group-text bi bi-calendar3"></i>
            </span>
          </div>
        </label>
      </div>
    </div>
    <div class="hidden-filters {% if more_filtered == False %}hide-row{% endif %}">
      <div class="row">
        <div class="form-group col">
          <label>{% trans "Наблюдатель" %}
            <select class="form-control selectpicker"
              data-style="btn"
              name="observer"
              autocomplete="off"
              id="observer-selection"
              data-size="20"
              data-live-search="true">
              <option value=""
                selected>{% trans "Все" %}</option>
              {% for author in authors %}
              <option data-author="{{ author.id }}"
                value="{{ author.id }}"
                {% if author.id == observer_id %}selected{% endif %}>{{ author.displayname }}</option>
              {% endfor %}
            </select>
          </label>
        </div>
        <div class="form-group col">
          <label>{% trans "Станция" %}
            <select class="form-control selectpicker"
              data-style="btn"
              name="station"
              autocomplete="off"
              data-size="20"
              id="station-selection"
              data-live-search="true">
              <option value=""
                selected>{% trans "Все" %}</option>
              {% for station in stations %}
              <option data-station="{{ station }}"
                value="{{ station.id }}"
                {% if station.id == station_id %}selected{% endif %}>
                {{ station.id }} - {{ station.name }}
              </option>
              {% endfor %}
            </select>
          </label>
        </div>
        <div class="form-group col">
          <label>{% trans "Результат" %}
            <select id="results-selection"
              class="form-control selectpicker def-val"
              aria-placeholder="All"
              data-style="btn"
              name="results"
              autocomplete="off"
              multiple
              data-none-selected-text="{% trans 'Все' %}">
              <optgroup label="{% trans 'Водопад' %}"
                data-icon="bi-distribute-horizontal"
                data-max-options="1">
                <option value="w1"
                  {% if 'w1' in results %}selected{% endif %}>{% trans "С водопадом" %}</option>
                <option value="w0"
                  {% if 'w0' in results %}selected{% endif %}>{% trans "Без водопада" %}</option>
              </optgroup>
              <optgroup label="{% trans 'Аудио' %}"
                data-icon="bi-volume-up-fill"
                data-max-options="1">
                <option value="a1"
                  {% if 'a1' in results %}selected{% endif %}>{% trans "С аудио" %}</option>
                <option value="a0"
                  {% if 'a0' in results %}selected{% endif %}>{% trans "Без аудио" %}</option>
              </optgroup>
              <optgroup label="{% trans 'Данные' %}"
                data-icon="bi-file-earmark-fill"
                data-max-options="1">
                <option value="d1"
                  {% if 'd1' in results %}selected{% endif %}>{% trans "С данными" %}</option>
                <option value="d0"
                  {% if 'd0' in results %}selected{% endif %}>{% trans "Без данных" %}</option>
              </optgroup>
              <optgroup label="{% trans 'Фото' %}"
                data-icon="bi-image"
                data-max-options="1">
                <option value="i1"
                  {% if 'i1' in results %}selected{% endif %}>{% trans "С фото" %}</option>
                <option value="i0"
                  {% if 'i0' in results %}selected{% endif %}>{% trans "Без фото" %}</option>
              </optgroup>
            </select>
          </label>
        </div>
        <div class="form-group col">
          <label>{% trans "Оценка наблюдения" %}
            <select id="results-selection"
              class="form-control selectpicker"
              data-style="btn"
              name="rated"
              autocomplete="off"
              multiple
              data-none-selected-text="{% trans 'Все' %}">
              <optgroup label="{% trans 'Водопад' %}"
                data-icon="bi-image"
                data-max-options="1">
                <option value="rwu"
                  {% if 'rwu' in rated %}selected{% endif %}>{% trans "Без оценки" %}</option>
                <option value="rw1"
                  {% if 'rw1' in rated %}selected{% endif %}>{% trans "С сигналом" %}</option>
                <option value="rw0"
                  {% if 'rw0' in rated %}selected{% endif %}>{% trans "Без сигнала" %}</option>
              </optgroup>
            </select>
          </label>
        </div>
      </div>
      <div class="row">
        <div class="form-group col">
          <label>{% trans "Модуляция" %}
            <div>
              <input type="text"
                id="observations-modulation"
                class="w-100"
                name="transmitter_mode"
                aria-labelledby="search-label"
                {% if transmitter_mode is not None %}value="{{ transmitter_mode }}"
                {% endif %}>
            </div>
          </label>
        </div>
        <div class="form-group col">
          <label>{% trans "Идентификатор передатчика" %}
            <select class="form-control selectpicker"
              data-style="btn"
              name="transmitter_uuid"
              autocomplete="off"
              data-size="20"
              id="transmitter-uuid-selection"
              data-live-search="true"
              data-live-search-placeholder="{% trans 'UUID | Спутник | NORAD' %}">
              <option value=""
                selected>{% trans "Все" %}</option>
              {% for uuid_enrty in transmitter_uuids_info %}
              <option data-transmitter_uuid="{{ uuid_enrty.uuid }}"
                data-satname="{{ uuid_enrty.satellite.name }}"
                data-norad="{{ uuid_enrty.satellite.norad_cat_id }}"
                value="{{ uuid_enrty.uuid }}"
                data-tokens="{{ uuid_enrty.satellite.norad_cat_id }} {{ uuid_enrty.satellite.name }}"
                {% if uuid_enrty.uuid == transmitters_uuid %}selected{% endif %}>
                {{ uuid_enrty.uuid }} | {{ uuid_enrty.satellite.name }} | {{ uuid_enrty.downlink_low }}
                {% trans "МГц" %}
              </option>
              {% endfor %}
            </select>
          </label>
        </div>
      </div>
    </div>
    <div class="row justify-content-between">
      <div class="col">
        <div id="show-all-filters"
          class="btn btn-big btn-gray {% if more_filtered == True %}show{% endif %}">
          {% if more_filtered == False %}
          {% trans "Больше фильтров" %}
          {% else %}
          {% trans "Меньше фильтров" %}
          {% endif %}
        </div>
      </div>
      <div class="col"></div>
      <div class="col"></div>
      <div class="col">
        <button type="submit"
          class="btn btn-big btn-blue">{% trans "Поиск" %}</button>
      </div>
    </div>
  </form>
</section>
<section class="container paginator">
  <div class="d-flex mt-2 mb-2 justify-content-between">
    <div class="buttons justify-content-start">
      {% if  observations %}
      {% csrf_token %}
      <button class="submit-vet-filter btn btn-small col-mb-12 btn-orange">{% trans "Режим просмотра" %}
        ({{ count_vet }})</button>
      {% if can_schedule %}<button
        class="btn btn-small btn-red future-obs-delete d-none">{% trans "Удалить" %}</button>{% endif %}
      <button class="btn btn-small btn-orange future-obs-show d-none">{% trans "Показать" %}</button>
      {% else %}
      <div></div>
      {% endif %}
    </div>
    {% if is_paginated %}
    {% load paginator %}
    {% paginator request 3 %}
    {% endif %}
  </div>
</section>
<section class="block-table">
  <div class="container">
    {% if observations %}
    <div id="observationsTable_wrapper"
      class="dataTables_wrapper">
      <div class="wrapper">
        <div class="responsive-table">
          <table id="observationsTable"
            class="table observations-table dataTable clickable hover">
            <thead>
              <tr>
                <th class="select-columns d-none"
                  data-auth="{{ user.is_authenticated }}"
                  {% if not user.is_authenticated %}style="display: none;"
                  {% endif %}>
                  <input type="checkbox"
                    autocomplete="off"
                    id="select-col-all">
                </th>
                <th class="first-column">{% trans "Номер" %}</th>
                <th>{% trans "Спутник" %}</th>
                <th>{% trans "Частота" %}</th>
                <th>{% trans "Модуляция" %}</th>
                <th>{% trans "Время" %}</th>
                <th>{% trans "Результат" %}</th>
                <th>{% trans "Наблюдатель" %}</th>
                <th>{% trans "Станция" %}</th>
              </tr>
            </thead>
            <tbody>
              {% for observation in observations %}
              <tr data-obs="{{ observation.id }}"
                data-href="{% url 'base:observation_view' observation_id=observation.id %}">
                <td class="select-column d-none">
                  <input type="checkbox"
                    autocomplete="off"
                    data-obsid="{{ observation.id }}"
                    {% if not user.is_authenticated %}style="display: none;"
                    {% endif %}>
                </td>
                <td class="first-column">
                  <a href="{% url 'base:observation_view' observation_id=observation.id %}"
                    class="obs-link">
                    {% if observation.is_future %}
                    <span class="badget badget-big badget-blue">{{ observation.id }}</span>
                    {% elif observation.status < -100 %}
                    <span class="badget badget-big badget-gray">{{ observation.id }}</span>
                    {% elif observation.status >= -100  and observation.status < 0 %}
                    <span class="badget badget-big badget-red">{{ observation.id }}</span>
                    {% elif observation.status >= 0  and observation.status < 100 %}
                    <span class="badget badget-big badget-orange">{{ observation.id }}</span>
                    {% elif observation.status >= 100 %}
                    <span class="badget badget-big badget-green">{{ observation.id }}</span>
                    {% endif %}
                  </a>
                </td>
                <td>
                  <div class="overlap-lines link">
                    <a href="#"
                      data-toggle="modal"
                      data-target="#SatelliteModal"
                      data-id="{{ observation.satellite.norad_cat_id }}"
                      data-sat-id="{{ observation.satellite.sat_id }}">{{ observation.satellite.name }}</a>
                  </div>
                </td>
                <td>
                  <div class="no-wrap">
                    {% if observation.center_frequency %}
                    {{ observation.center_frequency|frq }}
                    {% else %}
                    {{ observation.transmitter.downlink_low|frq }}
                    {% endif %}
                  </div>
                </td>
                <td>
                  <span data-toggle="tooltip"
                    data-placement="bottom"
                    title="{{ observation.transmitter.description }}">
                    {% if observation.transmitter.downlink_mode %}{{ observation.transmitter.downlink_mode }}{% endif %}
                    {% if observation.transmitter.baud %}-&nbsp;{% endif %}{{ observation.transmitter.baud|floatformat|default:" " }}
                  </span>
                </td>
                <td>
                  <span data-toggle="tooltip"
                    data-placement="bottom"
                    title="{{ observation.start|naturaltime_our }}"
                    class="datarow d-flex justify-content-between">
                    <span>{{ observation.start|date:"Y-m-d" }}</span>
                    &nbsp;
                    <span>{{ observation.start|date:"H:i:s" }}</span>
                  </span>
                  <span data-toggle="tooltip"
                    data-placement="bottom"
                    title="{{ observation.end|naturaltime_our }}"
                    class="datarow d-flex justify-content-between">
                    <span>{{ observation.end|date:"Y-m-d" }}</span>
                    &nbsp;
                    <span>{{ observation.end|date:"H:i:s" }}</span>
                  </span>
                </td>
                <td>
                  {% if observation.has_waterfall %}
                  <span class="bi bi-distribute-horizontal"
                    aria-hidden="true"
                    data-toggle="tooltip"
                    data-placement="bottom"
                    title="{% trans 'Водопад загружен' %}"></span>
                  {% endif %}
                  {% if observation.has_audio %}
                  <span class="bi bi-volume-up-fill"
                    aria-hidden="true"
                    data-toggle="tooltip"
                    data-placement="bottom"
                    title="{% trans 'Аудио загружено' %}"></span>
                  {% endif %}
                  {% if observation.image_count > 0 %}
                  <span class="bi bi-image"
                    aria-hidden="true"
                    data-toggle="tooltip"
                    data-placement="bottom"
                    title="{% trans 'Фотографии' %}"></span>
                  <span class="badget badget-small badget-gray">{{ observation.image_count }}</span>
                  {% endif %}
                  {% if observation.data_count > 0 %}
                  <span class="bi bi-file-earmark-fill"
                    aria-hidden="true"
                    data-toggle="tooltip"
                    data-placement="bottom"
                    title="{% trans 'Данные' %}"></span>
                  <span class="badget badget-small badget-gray">{{ observation.data_count }}</span>
                  {% endif %}
                </td>
                <td>
                  {% if observation.author %}
                  <div class="overlap-lines link">
                    <a href="{% url 'users:view_user' username=observation.author.username %}">
                      {{ observation.author.displayname }}
                      {% if observation.is_auto == True %}{%trans "(авто)"%}{% endif %}
                    </a>
                  </div>
                  {% else %}
                  -
                  {% endif %}
                </td>
                <td>
                  {% if observation.ground_station %}
                  <div class="overlap-lines link">
                    <a
                      href="{% url 'base:station_view' station_id=observation.ground_station.id %}">{{ observation.ground_station }}</a>
                  </div>
                  {% else %}
                  -
                  {% endif %}
                </td>
              </tr>
              {% endfor %}
            </tbody>
          </table>
        </div>
      </div>
    </div>
    {% else %}
    <p class="search_none_text">{% trans "По заданным фильтрам наблюдений не найдено" %}</p>
    {% endif %}
  </div>
</section>
<section class="container paginator">
  {% if is_paginated %}
  {% load paginator %}
  {% paginator request 3 %}
  {% endif %}
</section>
{% endblock content %}
{% block modal %}
<!-- Satellite Modal -->
{% include 'includes/satellite.html' %}

<!-- Modal observationsInfo-->
<div class="modal fade"
  id="modalobservationsInfo"
  tabindex="-1"
  role="dialog"
  aria-hidden="true">
  <div class="modal-dialog modal-md"
    role="document">
    <div class="modal-content">
      <div class="modal-header align-items-center">
        <span class="bi bi-info-circle"></span>
        {% trans "Информация" %}
      </div>
      <div class="modal-body">
        <p>
          {% trans "Идентификационный номер каждого наблюдения указан ниже и" %}&nbsp;{% trans "окрашен следующим образом" %}:
        </p>
        <ul class="badgets-info">
          <li>
            <span class="badget badget-big badget-blue">845</span>{% trans "Будущее наблюдение" %}&nbsp;&mdash;
            {% trans "это наблюдение запланировано" %}
          </li>
          <li>
            <span class="badget badget-big badget-green">312</span>{% trans "Хорошее наблюдение" %}&nbsp;&mdash;
            {% trans "спутник был активен в этом проходе" %}
          </li>
          <li>
            <span class="badget badget-big badget-red">576</span>{% trans "Плохое наблюдение" %}&nbsp;&mdash;
            {% trans "спутник не был активен в этом проходе" %}
          </li>
          <li>
            <span class="badget badget-big badget-orange">348</span>{% trans "Неизвестное наблюдение" %}&nbsp;&mdash;
            {% trans "в этом проходе есть данные, требующие проверки" %}
          </li>
          <li>
            <span class="badget badget-big badget-gray">105</span>{% trans "Наблюдение не удалось" %}&nbsp;&mdash;
            {% trans "на этом проходе неисправна наземная станция" %}
          </li>
        </ul>
      </div>
      <div class="modal-footer">
        <div class="btn btn-small btn-orange"
          data-dismiss="modal">{% trans "Скрыть" %}</div>
      </div>
    </div>
  </div>
</div>
<!-- / Modal observationsInfo -->
{% endblock modal %}
{% block javascript %}
<script src="{% static 'lib/moment/min/moment.min.js' %}"></script>
<script src="{% static 'lib/@popperjs/core/dist/umd/popper.min.js' %}"></script>
<script src="{% static 'lib/@eonasdan/tempus-dominus/dist/js/tempus-dominus.min.js' %}"></script>
<script src="{% static 'lib/@eonasdan/tempus-dominus/dist/plugins/customDateFormat.js' %}"></script>
<script src="{% static 'lib/bootstrap-select/dist/js/bootstrap-select.min.js' %}"></script>
<script src="{% static 'js/observations.js' %}"></script>
<script src="{% static 'js/satellite_modal.js' %}"></script>
{% endblock %}
